Settings

SpreadJS allows you to have flexible sparkline settings. You can control which value points are shown (such as high, low, first, last, or any negative values), change the type of the sparkline (Line, Column, or WinLoss), apply styles, and control whether to show the horizontal axis.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

You can highlight individual data markers (values) in a line sparkline by making some or all of the markers visible.

  • showFirst: whether the first data point is formatted differently for each sparkline in this sparkline group
  • showHigh: whether the data points with the highest value are formatted differently for each sparkline in this sparkline group
  • showLast: whether the last data point is formatted differently for each sparkline in this sparkline group
  • showLow: whether the data points with the lowest value are formatted differently for each sparkline in this sparkline group
  • showNegative: whether the negative data points are formatted differently for each sparkline in this sparkline group
  • showMarkers: whether data markers are displayed for each sparkline in this sparkline group

You can change the style and format of sparklines using the following methods:

  • axisColor: the color of the axis*
  • firstMarkerColor: the color of the first data point for each sparkline in this sparkline group
  • highMarkerColor: the color of the highest data point for each sparkline in this sparkline group
  • lastMarkerColor: the color of the last data point for each sparkline in this sparkline group
  • lowMarkerColor: the color of the lowest data point for each sparkline in this sparkline group
  • markersColor: the color of the data markers for each sparkline in this sparkline group
  • negativeColor: the color of the negative data points for each sparkline in this sparkline group
  • seriesColor: the color for each sparkline in this sparkline group

Sparklines offer additional settings. For example, sometimes there are empty values in the data series in the chart. You can use the displayEmptyCellsAs option to control how to display the empty cells, as shown in the following example:

    var setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
    setting.options.displayEmptyCellsAs = GC.Spread.Sheets.Sparklines.EmptyValueStyle.gaps;
    setting.options.rightToLeft = true;
    setting.options.displayHidden = false;
    setting.options.displayXAxis = false
    setting.options.lineWeight = 2;
    setting.options.manualMax = 3;
    setting.options.manualMin = 1;
    setting.options.markersColor = 'Magenta';
    setting.options.maxAxisType = GC.Spread.Sheets.Sparklines.SparklineAxisMinMax.custom;
    setting.options.minAxisType = GC.Spread.Sheets.Sparklines.SparklineAxisMinMax.individual;

The following example illustrates how to apply these settings:

    var setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
    setting.options.showFirst = true;
    setting.options.showHigh = true;
    setting.options.displayXAxis = true;
    setting.options.axisColor = 'Cyan';
    var sparkline = sheet.getSparkline(11, 0);
    sparkline.setting(setting);
You can highlight individual data markers (values) in a line sparkline by making some or all of the markers visible. showFirst: whether the first data point is formatted differently for each sparkline in this sparkline group showHigh: whether the data points with the highest value are formatted differently for each sparkline in this sparkline group showLast: whether the last data point is formatted differently for each sparkline in this sparkline group showLow: whether the data points with the lowest value are formatted differently for each sparkline in this sparkline group showNegative: whether the negative data points are formatted differently for each sparkline in this sparkline group showMarkers: whether data markers are displayed for each sparkline in this sparkline group You can change the style and format of sparklines using the following methods: axisColor: the color of the axis* firstMarkerColor: the color of the first data point for each sparkline in this sparkline group highMarkerColor: the color of the highest data point for each sparkline in this sparkline group lastMarkerColor: the color of the last data point for each sparkline in this sparkline group lowMarkerColor: the color of the lowest data point for each sparkline in this sparkline group markersColor: the color of the data markers for each sparkline in this sparkline group negativeColor: the color of the negative data points for each sparkline in this sparkline group seriesColor: the color for each sparkline in this sparkline group Sparklines offer additional settings. For example, sometimes there are empty values in the data series in the chart. You can use the displayEmptyCellsAs option to control how to display the empty cells, as shown in the following example: The following example illustrates how to apply these settings:
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById('ss')); initSpread(spread); }; function initSpread(spread) { var spreadNS = GC.Spread.Sheets; var sheet = spread.getSheet(0); sheet.suspendPaint(); sheet.options.allowCellOverflow = true; var data = [1,-2,-1,6,4,-4,3,8]; var dateAxis = [new Date(2011, 0, 5),new Date(2011, 0, 1),new Date(2011, 1, 11),new Date(2011, 2, 1), new Date(2011, 1, 1),new Date(2011, 1, 3),new Date(2011, 2, 6),new Date(2011, 1, 19)]; sheet.setValue(0, 0, "Series 1"); sheet.setValue(0, 1, "Series 2"); for(let i=0;i<8;i++) { sheet.setValue(i+1, 0,data[i]); sheet.getCell(i+1, 1).value(dateAxis[i]).formatter("yyyy-mm-dd"); } sheet.setColumnWidth(1,100); sheet.setValue(10, 0, "*Data Range is A2-A9"); sheet.setValue(11, 0, "*Date axis range is B2-B9"); var dataRange = new spreadNS.Range(1, 0, 8, 1); var dateAxisRange = new spreadNS.Range(1, 1, 8, 1); sheet.getCell(13, 0).text("Sparkline with dateAxis:"); sheet.getCell(14, 0).text("(1) Line"); sheet.getCell(14, 3).text("(2)Column"); sheet.getCell(14, 6).text("(3)Winloss"); //line sheet.addSpan(15, 0, 4, 3); var setting = new spreadNS.Sparklines.SparklineSetting(); setting.options.showMarkers = true; setting.options.displayXAxis = true; setting.options.showFirst = true; setting.options.showLast = true; setting.options.showLow = true; setting.options.showHigh = true; setting.options.showNegative = true; sheet.setSparkline(15, 0, dataRange , spreadNS.Sparklines.DataOrientation.vertical , spreadNS.Sparklines.SparklineType.line , setting , dateAxisRange , spreadNS.Sparklines.DataOrientation.vertical ); //column sheet.addSpan(15, 3, 4, 3); setting = new spreadNS.Sparklines.SparklineSetting(); setting.options.displayXAxis = true; setting.options.showFirst = true; setting.options.showLast = true; setting.options.showLow = true; setting.options.showHigh = true; setting.options.showNegative = true; sheet.setSparkline(15, 3, dataRange , spreadNS.Sparklines.DataOrientation.vertical , spreadNS.Sparklines.SparklineType.column , setting , dateAxisRange , spreadNS.Sparklines.DataOrientation.vertical ); //winloss sheet.addSpan(15, 6, 4, 3); setting = new spreadNS.Sparklines.SparklineSetting(); setting.options.displayXAxis = true; setting.options.showNegative = true; sheet.setSparkline(15, 6, dataRange , spreadNS.Sparklines.DataOrientation.vertical , spreadNS.Sparklines.SparklineType.winloss , setting , dateAxisRange , spreadNS.Sparklines.DataOrientation.vertical ); sheet.bind(spreadNS.Events.SelectionChanged, selectionChangedCallback); sheet.resumePaint(); function selectionChangedCallback() { var sheet = spread.getActiveSheet(); var sparkline = sheet.getSparkline(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex()); if (sparkline) { getSparklineSettings(sparkline); _getElementById('btnChangeSetting').disabled = false; } else { initSparklineSettings(); _getElementById('btnChangeSetting').disabled = true; } } function getActualRange(range, maxRowCount, maxColCount) { var row = range.row < 0 ? 0 : range.row; var col = range.col < 0 ? 0 : range.col; var rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount; var colCount = range.colCount < 0 ? maxColCount : range.colCount; return new spreadNS.Range(row, col, rowCount, colCount); } function findSparkLine(sheet, range) { var row = range.row, col = range.col, rowCount = range.rowCount, colCount = range.colCount; for (var i = 0; i < rowCount; i++) { for (var j = 0; j < colCount; j++) { var sparkline = sheet.getSparkline(row + i, col + j); if (sparkline != null) { return sparkline; } } } return null; } _getElementById('btnChangeSetting').addEventListener('click', function () { var sheet = spread.getActiveSheet(); sheet.suspendPaint(); var sels = sheet.getSelections(); var setting = new spreadNS.Sparklines.SparklineSetting(); var sparklinetype = _getElementById("sparklinetype"); var index = sparklinetype.selectedIndex; var sparklineType = parseInt(sparklinetype.options[index].value, 10); if (sels && sels.length > 0) { var sel = getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount()); var sparkline = findSparkLine(sheet, sel); if (sparkline != null) { sparkline.setting(buildSparklineSettings(setting)); sparkline.sparklineType(sparklineType); } } sheet.resumePaint(); }); function initSparklineSettings() { var sparklinetype = _getElementById("sparklinetype"); _selectOption(sparklinetype, '0'); _getElementById('firstMarkerColor').setAttribute('value', '(none)'); _getElementById('highMarkerColor').setAttribute('value', 'Blue'); _getElementById('lastMarkerColor').setAttribute('value', '(none)'); _getElementById('lowMarkerColor').setAttribute('value', 'Blue'); _getElementById('negativeMarkerColor').setAttribute('value', 'Brown'); _getElementById('markersColor').setAttribute('value', '(none)'); _getElementById('AxisColor').setAttribute('value', 'Black'); _getElementById('SeriesColor').setAttribute('value', '(none)'); _getElementById('showFirst').checked = false; _getElementById('showHigh').checked = false; _getElementById('showLast').checked = false; _getElementById('showLow').checked = false; _getElementById('showNegative').checked = false; _getElementById('showMarkers').checked = false; _getElementById('displayXAxis').checked = true; } function getSparklineSettings(sparkline) { var setting = sparkline.setting(); var sparklinetype = _getElementById("sparklinetype"); _selectOption(sparklinetype, sparkline.sparklineType() + ""); _getElementById('firstMarkerColor').setAttribute('value', setting.options.firstMarkerColor); _getElementById('highMarkerColor').setAttribute('value', setting.options.highMarkerColor); _getElementById('lastMarkerColor').setAttribute('value', setting.options.lastMarkerColor); _getElementById('lowMarkerColor').setAttribute('value', setting.options.lowMarkerColor); _getElementById('negativeMarkerColor').setAttribute('value', setting.options.negativeColor); _getElementById('markersColor').setAttribute('value', setting.options.markersColor); _getElementById('AxisColor').setAttribute('value', setting.options.axisColor); _getElementById('SeriesColor').setAttribute('value', setting.options.seriesColor); _getElementById('showFirst').checked = setting.options.showFirst; _getElementById('showHigh').checked = setting.options.showHigh; _getElementById('showLast').checked = setting.options.showLast; _getElementById('showLow').checked = setting.options.showLow; _getElementById('showNegative').checked = setting.options.showNegative; _getElementById('showMarkers').checked = setting.options.showMarkers; _getElementById('displayXAxis').checked = setting.options.displayXAxis; } function buildSparklineSettings(setting) { if (setting == null) setting = new spreadNS.Sparklines.SparklineSetting(); var firstMarkerColor = _getElementById('firstMarkerColor'); if (firstMarkerColor.value != '(none)') setting.options.firstMarkerColor = firstMarkerColor.value; var highMarkerColor = _getElementById('highMarkerColor'); if (highMarkerColor.value != '(none)') setting.options.highMarkerColor = highMarkerColor.value; var lastMarkerColor = _getElementById('lastMarkerColor'); if (lastMarkerColor.value != '(none)') setting.options.lastMarkerColor = lastMarkerColor.value; var lowMarkerColor = _getElementById('lowMarkerColor'); if (lowMarkerColor.value != '(none)') setting.options.lowMarkerColor = lowMarkerColor.value; var negativeMarkerColor = _getElementById('negativeMarkerColor'); if (negativeMarkerColor.value != '(none)') setting.options.negativeColor = negativeMarkerColor.value; var markersColor = _getElementById('markersColor'); if (markersColor.value != '(none)') setting.options.markersColor = markersColor.value; var AxisColor = _getElementById('AxisColor'); if (AxisColor.value != '(none)') setting.options.axisColor = AxisColor.value; var SeriesColor = _getElementById('SeriesColor'); if (SeriesColor.value != '(none)') setting.options.seriesColor = SeriesColor.value; setting.options.showFirst = _getElementById('showFirst').checked; setting.options.showHigh = _getElementById('showHigh').checked; setting.options.showLast = _getElementById('showLast').checked; setting.options.showLow = _getElementById('showLow').checked; setting.options.showNegative = _getElementById('showNegative').checked; setting.options.showMarkers = _getElementById('showMarkers').checked; setting.options.displayXAxis = _getElementById('displayXAxis').checked; return setting; } } function _getElementById(id) { return document.getElementById(id); } function _selectOption(select, value) { for (var i = 0; i < select.length; i++) { var op = select.options[i]; if (op.value === value) { op.selected = true; } else { op.selected = false; } } }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> <label>*Select a sparkline in the spreadsheet then change its properties</label> </div> <div class="option-row"> <div class="option"> <input id='btnChangeSetting' type='button' value='Change Setting'/> </div> </div> <div class="option-row"> <div class="option"> <input id='showFirst' type='checkbox'/> <label for="showFirst">showFirst</label> </div> <div class="option"> <input id='showHigh' type='checkbox'/> <label for="showHigh">showHigh</label> </div> <div class="option"> <input id='showLast' type='checkbox'/> <label for="showLast">showLast</label> </div> <div class="option"> <input id='showLow' type='checkbox'/> <label for="showLow">showLow</label> </div> <div class="option"> <input id='showNegative' type='checkbox'/> <label for="showNegative">showNegative</label> </div> <div class="option"> <input id='showMarkers' type='checkbox'/> <label for="showMarkers">showMarkers</label> </div> <div class="option"> <input id="displayXAxis" type="checkbox"/> <label for="displayXAxis">displayXAxis</label> </div> </div> <div class="option-row"> <div class="option"> <label for="firstMarkerColor" class="block">First Marker Color</label> <input id='firstMarkerColor' class="control" value="(none)"/> </div> <div class="option"> <label for="sparklinetype" class="block">Type:</label> <select id="sparklinetype" class="control"> <option value="0">line</option> <option value="1">column</option> <option value="2">winloss</option> </select> </div> <div class="option"> <label for="highMarkerColor" class="block">High Marker Color</label> <input id='highMarkerColor' class="control" value="Blue"/> </div> <div class="option"> <label for="lastMarkerColor" class="block">Last Marker Color</label> <input id='lastMarkerColor' class="control" value="(none)"/> </div> <div class="option"> <label for="lowMarkerColor" class="block">Low Marker Color</label> <input id='lowMarkerColor' class="control" value="Blue"/> </div> <div class="option"> <label for="negativeMarkerColor" class="block">Negative Marker Color</label> <input id='negativeMarkerColor' class="control" value="Brown"/> </div> <div class="option"> <label for="markersColor" class="block">Markers Color</label> <input id='markersColor' class="control" value="(none)"/> </div> <div class="option"> <label for="AxisColor" class="block">Axis Color</label> <input id='AxisColor' class="control" value="Black"/> </div> <div class="option"> <label for="SeriesColor" class="block">SeriesColor</label> <input id='SeriesColor' class="control" value="(none)"/> </div> </div> </div> </div> </body> </html>
.sample { position: relative; height: 100%; overflow: auto; } .sample::after { display: block; content: ""; clear: both; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } .option { padding-bottom: 6px; } .block { display: block; padding: 6px 0; } .control { padding: 4px 8px; box-sizing: border-box; width: 100%; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

You can highlight individual data markers (values) in a line sparkline by making some or all of the markers visible.
showFirst: whether the first data point is formatted differently for each sparkline in this sparkline group
showHigh: whether the data points with the highest value are formatted differently for each sparkline in this sparkline group
showLast: whether the last data point is formatted differently for each sparkline in this sparkline group
showLow: whether the data points with the lowest value are formatted differently for each sparkline in this sparkline group
showNegative: whether the negative data points are formatted differently for each sparkline in this sparkline group
showMarkers: whether data markers are displayed for each sparkline in this sparkline group
You can change the style and format of sparklines using the following methods:
axisColor: the color of the axis*
firstMarkerColor: the color of the first data point for each sparkline in this sparkline group
highMarkerColor: the color of the highest data point for each sparkline in this sparkline group
lastMarkerColor: the color of the last data point for each sparkline in this sparkline group
lowMarkerColor: the color of the lowest data point for each sparkline in this sparkline group
markersColor: the color of the data markers for each sparkline in this sparkline group
negativeColor: the color of the negative data points for each sparkline in this sparkline group
seriesColor: the color for each sparkline in this sparkline group
Sparklines offer additional settings. For example, sometimes there are empty values in the data series in the chart. You can use the displayEmptyCellsAs option to control how to display the empty cells, as shown in the following example:
The following example illustrates how to apply these settings:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
let spread = null;
export function AppFunc() {
const [sparklineSetting, setSparklineSetting] = React.useState({
firstMarkerColor: '(none)',
buttonDisable: true,
type: 0,
highMarkerColor: 'Blue',
lastMarkerColor: '(none)',
lowMarkerColor: 'Blue',
negativeMarkerColor: 'Brown',
markersColor: '(none)',
axisColor: 'black',
seriesColor: '(none)',
showFirst: false,
showHigh: false,
showLast: false,
showLow: false,
showNegative: true,
showMarkers: false,
displayXAxis: true
});
const buttonClick = () => {
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
let sels = sheet.getSelections();
let setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
let sparklineType = sparklineSetting.type;
if (sels && sels.length > 0) {
let sel = getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount());
let sparkline = findSparkLine(sheet, sel);
if (sparkline != null) {
sparkline.setting(buildSparklineSettings(setting));
sparkline.sparklineType(sparklineType);
}
}
sheet.resumePaint();
}
const showFirstChange = (e) => {
let value = e.target.checked;
setSparklineSetting({
...sparklineSetting,
showFirst: value
});
}
const showHighChange = (e) => {
let value = e.target.checked;
setSparklineSetting({
...sparklineSetting,
showHigh: value
});
}
const showLastChange = (e) => {
let value = e.target.checked;
setSparklineSetting({
...sparklineSetting,
showLast: value
});
}
const showLowChange = (e) => {
let value = e.target.checked;
setSparklineSetting({
...sparklineSetting,
showLow: value
});
}
const showNegativeChange = (e) => {
let value = e.target.checked;
setSparklineSetting({
...sparklineSetting,
showNegative: value
});
}
const showMarkersChange = (e) => {
let value = e.target.checked;
setSparklineSetting({
...sparklineSetting,
showMarkers: value
});
}
const displayXAxisChange = (e) => {
let value = e.target.checked;
setSparklineSetting({
...sparklineSetting,
displayXAxis: value
});
}
const firstMarkerColorChange = (e) => {
let value = e.target.value;
setSparklineSetting({
...sparklineSetting,
firstMarkerColor: value
});
}
const typeChange = (e) => {
let value = parseInt(e.target.value);
setSparklineSetting({
...sparklineSetting,
type: value
});
}
const highMarkerColorChange = (e) => {
let value = e.target.value;
setSparklineSetting({
...sparklineSetting,
highMarkerColor: value
});
}
const lastMarkerColorChange = (e) => {
let value = e.target.value;
setSparklineSetting({
...sparklineSetting,
lastMarkerColor: value
});
}
const lowMarkerColorChange = (e) => {
let value = e.target.value;
setSparklineSetting({
...sparklineSetting,
lowMarkerColor: value
});
}
const negativeMarkerColorChange = (e) => {
let value = e.target.value;
setSparklineSetting({
...sparklineSetting,
negativeMarkerColor: value
});
}
const markersColorChange = (e) => {
let value = e.target.value;
setSparklineSetting({
...sparklineSetting,
markersColor: value
});
}
const axisColorChange = (e) => {
let value = e.target.value;
setSparklineSetting({
...sparklineSetting,
axisColor: value
});
}
const seriesColorChange = (e) => {
let value = e.target.value;
setSparklineSetting({
...sparklineSetting,
seriesColor: value
});
}
const getActualRange = (range, maxRowCount, maxColCount) => {
let row = range.row < 0 ? 0 : range.row;
let col = range.col < 0 ? 0 : range.col;
let rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
let colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new GC.Spread.Sheets.Range(row, col, rowCount, colCount);
}
const findSparkLine = (sheet, range) => {
let row = range.row,
col = range.col,
rowCount = range.rowCount,
colCount = range.colCount;
for (let i = 0; i < rowCount; i++) {
for (let j = 0; j < colCount; j++) {
let sparkline = sheet.getSparkline(row + i, col + j);
if (sparkline != null) {
return sparkline;
}
}
}
return null;
}
const buildSparklineSettings = (setting) => {
if (setting == null) setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
let firstMarkerColor = sparklineSetting.firstMarkerColor;
if (firstMarkerColor != '(none)') setting.options.firstMarkerColor = firstMarkerColor;
let highMarkerColor = sparklineSetting.highMarkerColor;
if (highMarkerColor != '(none)') setting.options.highMarkerColor = highMarkerColor;
let lastMarkerColor = sparklineSetting.lastMarkerColor;
if (lastMarkerColor != '(none)') setting.options.lastMarkerColor = lastMarkerColor;
let lowMarkerColor = sparklineSetting.lowMarkerColor;
if (lowMarkerColor != '(none)') setting.options.lowMarkerColor = lowMarkerColor;
let negativeMarkerColor = sparklineSetting.negativeMarkerColor;
if (negativeMarkerColor != '(none)') setting.options.negativeColor = negativeMarkerColor;
let markersColor = sparklineSetting.markersColor;
if (markersColor != '(none)') setting.options.markersColor = markersColor;
let AxisColor = sparklineSetting.axisColor;
if (AxisColor != '(none)') setting.options.axisColor = AxisColor;
let SeriesColor = sparklineSetting.seriesColor;
if (SeriesColor != '(none)') setting.options.seriesColor = SeriesColor;
setting.options.showFirst = sparklineSetting.showFirst;
setting.options.showHigh = sparklineSetting.showHigh;
setting.options.showLast = sparklineSetting.showLast;
setting.options.showLow = sparklineSetting.showLow;
setting.options.showNegative = sparklineSetting.showNegative;
setting.options.showMarkers = sparklineSetting.showMarkers;
setting.options.displayXAxis = sparklineSetting.displayXAxis;
return setting;
}
const initSpread = (currSpread) => {
spread = currSpread;
let spreadNS = GC.Spread.Sheets;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.allowCellOverflow = true;
var data = [1,-2,-1,6,4,-4,3,8];
var dateAxis = [new Date(2011, 0, 5),new Date(2011, 0, 1),new Date(2011, 1, 11),new Date(2011, 2, 1),
new Date(2011, 1, 1),new Date(2011, 1, 3),new Date(2011, 2, 6),new Date(2011, 1, 19)];
sheet.setValue(0, 0, "Series 1");
sheet.setValue(0, 1, "Series 2");
for(let i=0;i<8;i++)
{
sheet.setValue(i+1, 0,data[i]);
sheet.getCell(i+1, 1).value(dateAxis[i]).formatter("yyyy-mm-dd");
}
sheet.setColumnWidth(1,100);
sheet.setValue(10, 0, "*Data Range is A2-A9");
sheet.setValue(11, 0, "*Date axis range is B2-B9");
var dataRange = new spreadNS.Range(1, 0, 8, 1);
var dateAxisRange = new spreadNS.Range(1, 1, 8, 1);
sheet.getCell(13, 0).text("Sparkline with dateAxis:");
sheet.getCell(14, 0).text("(1) Line");
sheet.getCell(14, 3).text("(2)Column");
sheet.getCell(14, 6).text("(3)Winloss");
//line
sheet.addSpan(15, 0, 4, 3);
var setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.showMarkers = true;
setting.options.displayXAxis = true;
setting.options.showFirst = true;
setting.options.showLast = true;
setting.options.showLow = true;
setting.options.showHigh = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 0, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.line
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
//column
sheet.addSpan(15, 3, 4, 3);
setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.displayXAxis = true;
setting.options.showFirst = true;
setting.options.showLast = true;
setting.options.showLow = true;
setting.options.showHigh = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 3, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.column
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
//winloss
sheet.addSpan(15, 6, 4, 3);
setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.displayXAxis = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 6, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.winloss
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
sheet.bind(GC.Spread.Sheets.Events.SelectionChanged, selectionChangedCallback);
sheet.resumePaint();
function selectionChangedCallback() {
let sheet = spread.getActiveSheet();
let sparkline = sheet.getSparkline(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (sparkline) {
getSparklineSettings(sparkline);
setSparklineSetting({
...sparklineSetting,
buttonDisable: false
});
} else {
initSparklineSettings();
setSparklineSetting({
...sparklineSetting,
buttonDisable: true
});
}
}
function initSparklineSettings() {
setSparklineSetting({
...sparklineSetting,
type: 0,
firstMarkerColor: '(none)',
highMarkerColor: 'Blue',
lastMarkerColor: '(none)',
lowMarkerColor: 'Blue',
negativeMarkerColor: 'Brown',
markersColor: '(none)',
axisColor: 'Black',
seriesColor: '(none)',
showFirst: false,
showHigh: false,
showLow: false,
showLast: false,
showNegative: false,
showMarkers: false,
displayXAxis: true
});
}
function getSparklineSettings(sparkline) {
let setting = sparkline.setting();
setSparklineSetting({
...sparklineSetting,
type: sparkline.sparklineType(),
firstMarkerColor: setting.options.firstMarkerColor,
highMarkerColor: setting.options.highMarkerColor,
lastMarkerColor: setting.options.lastMarkerColor,
lowMarkerColor: setting.options.lowMarkerColor,
negativeMarkerColor: setting.options.negativeColor,
markersColor: setting.options.markersColor,
axisColor: setting.options.axisColor,
seriesColor: setting.options.seriesColor,
showFirst: setting.options.showFirst,
showHigh: setting.options.showHigh,
showLow: setting.options.showLow,
showLast: setting.options.showLast,
showNegative: setting.options.showNegative,
showMarkers: setting.options.showMarkers,
displayXAxis: setting.options.displayXAxis
});
}
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
panelInfo={sparklineSetting} buttonClick={() => { buttonClick() }} showFirstChange={(e) => { showFirstChange(e) }}
showHighChange={(e) => { showHighChange(e) }} showLastChange={(e) => { showLastChange(e) }} showLowChange={(e) => { showLowChange(e) }}
showNegativeChange={(e) => { showNegativeChange(e) }} showMarkersChange={(e) => { showMarkersChange(e) }}
displayXAxisChange={(e) => { displayXAxisChange(e) }} firstMarkerColorChange={(e) => { firstMarkerColorChange(e) }}
typeChange={(e) => { typeChange(e) }} highMarkerColorChange={(e) => { highMarkerColorChange(e) }} lastMarkerColorChange={(e) => { lastMarkerColorChange(e) }}
lowMarkerColorChange={(e) => { lowMarkerColorChange(e) }} negativeMarkerColorChange={(e) => { negativeMarkerColorChange(e) }}
markersColorChange={(e) => { markersColorChange(e) }} axisColorChange={(e) => { axisColorChange(e) }}
seriesColorChange={(e) => { seriesColorChange(e) }}
></Panel>
</div>
);
}
const Panel = (props) => {
const { panelInfo, buttonClick, showFirstChange,
showHighChange, showLastChange, showLowChange,
showNegativeChange, showMarkersChange,
displayXAxisChange, firstMarkerColorChange,
typeChange, highMarkerColorChange, lastMarkerColorChange,
lowMarkerColorChange, negativeMarkerColorChange,
markersColorChange, axisColorChange,
seriesColorChange } = props;
return (
<div class="options-container">
<div class="option-row">
<label>*Select a sparkline in the spreadsheet then change its properties</label>
</div>
<div class="option-row">
<div class="option">
<input id='btnChangeSetting' type='button' disabled={panelInfo.buttonDisable} value='Change Setting' onClick={() => { buttonClick() }} />
</div>
</div>
<div class="option-row">
<div class="option">
<input checked={panelInfo.showFirst} id='showFirst' type='checkbox' onChange={(e) => { showFirstChange(e) }} />
<label for="showFirst">showFirst</label>
</div>
<div class="option">
<input checked={panelInfo.showHigh} id='showHigh' type='checkbox' onChange={(e) => { showHighChange(e) }} />
<label for="showHigh">showHigh</label>
</div>
<div class="option">
<input id='showLast' type='checkbox' checked={panelInfo.showLast} onChange={(e) => { showLastChange(e) }} />
<label for="showLast">showLast</label>
</div>
<div class="option">
<input id='showLow' type='checkbox' checked={panelInfo.showLow} onChange={(e) => { showLowChange(e) }} />
<label for="showLow">showLow</label>
</div>
<div class="option">
<input id='showNegative' type='checkbox' checked={panelInfo.showNegative} onChange={(e) => { showNegativeChange(e) }} />
<label for="showNegative">showNegative</label>
</div>
<div class="option">
<input id='showMarkers' type='checkbox' checked={panelInfo.showMarkers} onChange={(e) => { showMarkersChange(e) }} />
<label for="showMarkers">showMarkers</label>
</div>
<div class="option">
<input id="displayXAxis" type="checkbox" checked={panelInfo.displayXAxis} onChange={(e) => { displayXAxisChange(e) }} />
<label for="displayXAxis">displayXAxis</label>
</div>
</div>
<div class="option-row">
<div class="option">
<label for="firstMarkerColor" class="block">First Marker Color</label>
<input id='firstMarkerColor' class="control" value={panelInfo.firstMarkerColor} onChange={(e) => { firstMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="sparklinetype" class="block">Type:</label>
<select id="sparklinetype" class="control" value={panelInfo.type} onChange={(e) => { typeChange(e) }}>
<option value="0">line</option>
<option value="1">column</option>
<option value="2">winloss</option>
</select>
</div>
<div class="option">
<label for="highMarkerColor" class="block">High Marker Color</label>
<input id='highMarkerColor' class="control" value={panelInfo.highMarkerColor} onChange={(e) => { highMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="lastMarkerColor" class="block">Last Marker Color</label>
<input id='lastMarkerColor' class="control" value={panelInfo.lastMarkerColor} onChange={(e) => { lastMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="lowMarkerColor" class="block">Low Marker Color</label>
<input id='lowMarkerColor' class="control" value={panelInfo.lowMarkerColor} onChange={(e) => { lowMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="negativeMarkerColor" class="block">Negative Marker Color</label>
<input id='negativeMarkerColor' class="control" value={panelInfo.negativeMarkerColor} onChange={(e) => { negativeMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="markersColor" class="block">Markers Color</label>
<input id='markersColor' class="control" value={panelInfo.markersColor} onChange={(e) => { markersColorChange(e) }} />
</div>
<div class="option">
<label for="AxisColor" class="block">Axis Color</label>
<input id='AxisColor' class="control" value={panelInfo.axisColor} onChange={(e) => { axisColorChange(e) }} />
</div>
<div class="option">
<label for="SeriesColor" class="block">SeriesColor</label>
<input id='SeriesColor' class="control" value={panelInfo.seriesColor} onChange={(e) => { seriesColorChange(e) }} />
</div>
</div>
</div>
)
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
firstMarkerColor: '(none)',
buttonDisable: true,
type: 0,
highMarkerColor: 'Blue',
lastMarkerColor: '(none)',
lowMarkerColor: 'Blue',
negativeMarkerColor: 'Brown',
markersColor: '(none)',
axisColor: 'black',
seriesColor: '(none)',
showFirst: false,
showHigh: false,
showLast: false,
showLow: false,
showNegative: true,
showMarkers: false,
displayXAxis: true
}
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
panelInfo={this.state} buttonClick={() => { this.buttonClick() }} showFirstChange={(e) => { this.showFirstChange(e) }}
showHighChange={(e) => { this.showHighChange(e) }} showLastChange={(e) => { this.showLastChange(e) }} showLowChange={(e) => { this.showLowChange(e) }}
showNegativeChange={(e) => { this.showNegativeChange(e) }} showMarkersChange={(e) => { this.showMarkersChange(e) }}
displayXAxisChange={(e) => { this.displayXAxisChange(e) }} firstMarkerColorChange={(e) => { this.firstMarkerColorChange(e) }}
typeChange={(e) => { this.typeChange(e) }} highMarkerColorChange={(e) => { this.highMarkerColorChange(e) }} lastMarkerColorChange={(e) => { this.lastMarkerColorChange(e) }}
lowMarkerColorChange={(e) => { this.lowMarkerColorChange(e) }} negativeMarkerColorChange={(e) => { this.negativeMarkerColorChange(e) }}
markersColorChange={(e) => { this.markersColorChange(e) }} axisColorChange={(e) => { this.axisColorChange(e) }}
seriesColorChange={(e) => { this.seriesColorChange(e) }}
></Panel>
</div>
)
}
buttonClick() {
let sheet = this.spread.getActiveSheet();
sheet.suspendPaint();
let sels = sheet.getSelections();
let setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
let sparklineType = this.state.type;
if (sels && sels.length > 0) {
let sel = this.getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount());
let sparkline = this.findSparkLine(sheet, sel);
if (sparkline != null) {
sparkline.setting(this.buildSparklineSettings(setting));
sparkline.sparklineType(sparklineType);
}
}
sheet.resumePaint();
}
showFirstChange(e) {
let value = e.target.checked;
this.setState(() => ({
showFirst: value
}));
}
showHighChange(e) {
let value = e.target.checked;
this.setState(() => ({
showHigh: value
}));
}
showLastChange(e) {
let value = e.target.checked;
this.setState(() => ({
showLast: value
}));
}
showLowChange(e) {
let value = e.target.checked;
this.setState(() => ({
showLow: value
}));
}
showNegativeChange(e) {
let value = e.target.checked;
this.setState(() => ({
showNegative: value
}));
}
showMarkersChange(e) {
let value = e.target.checked;
this.setState(() => ({
showMarkers: value
}));
}
displayXAxisChange(e) {
let value = e.target.checked;
this.setState(() => ({
displayXAxis: value
}));
}
firstMarkerColorChange(e) {
let value = e.target.value;
this.setState(() => ({
firstMarkerColor: value
}));
}
typeChange(e) {
let value = parseInt(e.target.value);
this.setState(() => ({
type: value
}));
}
highMarkerColorChange(e) {
let value = e.target.value;
this.setState(() => ({
highMarkerColor: value
}));
}
lastMarkerColorChange(e) {
let value = e.target.value;
this.setState(() => ({
lastMarkerColor: value
}));
}
lowMarkerColorChange(e) {
let value = e.target.value;
this.setState(() => ({
lowMarkerColor: value
}));
}
negativeMarkerColorChange(e) {
let value = e.target.value;
this.setState(() => ({
negativeMarkerColor: value
}));
}
markersColorChange(e) {
let value = e.target.value;
this.setState(() => ({
markersColor: value
}));
}
axisColorChange(e) {
let value = e.target.value;
this.setState(() => ({
axisColor: value
}));
}
seriesColorChange(e) {
let value = e.target.value;
this.setState(() => ({
seriesColor: value
}));
}
getActualRange(range, maxRowCount, maxColCount) {
let row = range.row < 0 ? 0 : range.row;
let col = range.col < 0 ? 0 : range.col;
let rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
let colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new GC.Spread.Sheets.Range(row, col, rowCount, colCount);
}
findSparkLine(sheet, range) {
let row = range.row,
col = range.col,
rowCount = range.rowCount,
colCount = range.colCount;
for (let i = 0; i < rowCount; i++) {
for (let j = 0; j < colCount; j++) {
let sparkline = sheet.getSparkline(row + i, col + j);
if (sparkline != null) {
return sparkline;
}
}
}
return null;
}
buildSparklineSettings(setting) {
if (setting == null) setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
let firstMarkerColor = this.state.firstMarkerColor;
if (firstMarkerColor != '(none)') setting.options.firstMarkerColor = firstMarkerColor;
let highMarkerColor = this.state.highMarkerColor;
if (highMarkerColor != '(none)') setting.options.highMarkerColor = highMarkerColor;
let lastMarkerColor = this.state.lastMarkerColor;
if (lastMarkerColor != '(none)') setting.options.lastMarkerColor = lastMarkerColor;
let lowMarkerColor = this.state.lowMarkerColor;
if (lowMarkerColor != '(none)') setting.options.lowMarkerColor = lowMarkerColor;
let negativeMarkerColor = this.state.negativeMarkerColor;
if (negativeMarkerColor != '(none)') setting.options.negativeColor = negativeMarkerColor;
let markersColor = this.state.markersColor;
if (markersColor != '(none)') setting.options.markersColor = markersColor;
let AxisColor = this.state.axisColor;
if (AxisColor != '(none)') setting.options.axisColor = AxisColor;
let SeriesColor = this.state.seriesColor;
if (SeriesColor != '(none)') setting.options.seriesColor = SeriesColor;
setting.options.showFirst = this.state.showFirst;
setting.options.showHigh = this.state.showHigh;
setting.options.showLast = this.state.showLast;
setting.options.showLow = this.state.showLow;
setting.options.showNegative = this.state.showNegative;
setting.options.showMarkers = this.state.showMarkers;
setting.options.displayXAxis = this.state.displayXAxis;
return setting;
}
initSpread(spread) {
this.spread = spread;
let spreadNS = GC.Spread.Sheets;
let self = this;
let sheet = this.spread.getSheet(0);
sheet.suspendPaint();
sheet.options.allowCellOverflow = true;
var data = [1,-2,-1,6,4,-4,3,8];
var dateAxis = [new Date(2011, 0, 5),new Date(2011, 0, 1),new Date(2011, 1, 11),new Date(2011, 2, 1),
new Date(2011, 1, 1),new Date(2011, 1, 3),new Date(2011, 2, 6),new Date(2011, 1, 19)];
sheet.setValue(0, 0, "Series 1");
sheet.setValue(0, 1, "Series 2");
for(let i=0;i<8;i++)
{
sheet.setValue(i+1, 0,data[i]);
sheet.getCell(i+1, 1).value(dateAxis[i]).formatter("yyyy-mm-dd");
}
sheet.setColumnWidth(1,100);
sheet.setValue(10, 0, "*Data Range is A2-A9");
sheet.setValue(11, 0, "*Date axis range is B2-B9");
var dataRange = new spreadNS.Range(1, 0, 8, 1);
var dateAxisRange = new spreadNS.Range(1, 1, 8, 1);
sheet.getCell(13, 0).text("Sparkline with dateAxis:");
sheet.getCell(14, 0).text("(1) Line");
sheet.getCell(14, 3).text("(2)Column");
sheet.getCell(14, 6).text("(3)Winloss");
//line
sheet.addSpan(15, 0, 4, 3);
var setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.showMarkers = true;
setting.options.displayXAxis = true;
setting.options.showFirst = true;
setting.options.showLast = true;
setting.options.showLow = true;
setting.options.showHigh = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 0, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.line
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
//column
sheet.addSpan(15, 3, 4, 3);
setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.displayXAxis = true;
setting.options.showFirst = true;
setting.options.showLast = true;
setting.options.showLow = true;
setting.options.showHigh = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 3, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.column
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
//winloss
sheet.addSpan(15, 6, 4, 3);
setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.displayXAxis = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 6, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.winloss
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
sheet.bind(GC.Spread.Sheets.Events.SelectionChanged, selectionChangedCallback);
sheet.resumePaint();
function selectionChangedCallback() {
let sheet = self.spread.getActiveSheet();
let sparkline = sheet.getSparkline(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (sparkline) {
getSparklineSettings(sparkline);
self.setState(() => ({
buttonDisable: false
}));
} else {
initSparklineSettings();
self.setState(() => ({
buttonDisable: true
}));
}
}
function initSparklineSettings() {
self.setState(() => ({
type: 0,
firstMarkerColor: '(none)',
highMarkerColor: 'Blue',
lastMarkerColor: '(none)',
lowMarkerColor: 'Blue',
negativeMarkerColor: 'Brown',
markersColor: '(none)',
axisColor: 'Black',
seriesColor: '(none)',
showFirst: false,
showHigh: false,
showLow: false,
showLast: false,
showNegative: false,
showMarkers: false,
displayXAxis: true
}));
}
function getSparklineSettings(sparkline) {
let setting = sparkline.setting();
self.setState({
type: sparkline.sparklineType(),
firstMarkerColor: setting.options.firstMarkerColor,
highMarkerColor: setting.options.highMarkerColor,
lastMarkerColor: setting.options.lastMarkerColor,
lowMarkerColor: setting.options.lowMarkerColor,
negativeMarkerColor: setting.options.negativeColor,
markersColor: setting.options.markersColor,
axisColor: setting.options.axisColor,
seriesColor: setting.options.seriesColor,
showFirst: setting.options.showFirst,
showHigh: setting.options.showHigh,
showLow: setting.options.showLow,
showLast: setting.options.showLast,
showNegative: setting.options.showNegative,
showMarkers: setting.options.showMarkers,
displayXAxis: setting.options.displayXAxis
});
}
}
}
const Panel = (props) => {
const { panelInfo, buttonClick, showFirstChange,
showHighChange, showLastChange, showLowChange,
showNegativeChange, showMarkersChange,
displayXAxisChange, firstMarkerColorChange,
typeChange, highMarkerColorChange, lastMarkerColorChange,
lowMarkerColorChange, negativeMarkerColorChange,
markersColorChange, axisColorChange,
seriesColorChange } = props;
return (
<div class="options-container">
<div class="option-row">
<label>*Select a sparkline in the spreadsheet then change its properties</label>
</div>
<div class="option-row">
<div class="option">
<input id='btnChangeSetting' type='button' disabled={panelInfo.buttonDisable} value='Change Setting' onClick={() => { buttonClick() }} />
</div>
</div>
<div class="option-row">
<div class="option">
<input checked={panelInfo.showFirst} id='showFirst' type='checkbox' onChange={(e) => { showFirstChange(e) }} />
<label for="showFirst">showFirst</label>
</div>
<div class="option">
<input checked={panelInfo.showHigh} id='showHigh' type='checkbox' onChange={(e) => { showHighChange(e) }} />
<label for="showHigh">showHigh</label>
</div>
<div class="option">
<input id='showLast' type='checkbox' checked={panelInfo.showLast} onChange={(e) => { showLastChange(e) }} />
<label for="showLast">showLast</label>
</div>
<div class="option">
<input id='showLow' type='checkbox' checked={panelInfo.showLow} onChange={(e) => { showLowChange(e) }} />
<label for="showLow">showLow</label>
</div>
<div class="option">
<input id='showNegative' type='checkbox' checked={panelInfo.showNegative} onChange={(e) => { showNegativeChange(e) }} />
<label for="showNegative">showNegative</label>
</div>
<div class="option">
<input id='showMarkers' type='checkbox' checked={panelInfo.showMarkers} onChange={(e) => { showMarkersChange(e) }} />
<label for="showMarkers">showMarkers</label>
</div>
<div class="option">
<input id="displayXAxis" type="checkbox" checked={panelInfo.displayXAxis} onChange={(e) => { displayXAxisChange(e) }} />
<label for="displayXAxis">displayXAxis</label>
</div>
</div>
<div class="option-row">
<div class="option">
<label for="firstMarkerColor" class="block">First Marker Color</label>
<input id='firstMarkerColor' class="control" value={panelInfo.firstMarkerColor} onChange={(e) => { firstMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="sparklinetype" class="block">Type:</label>
<select id="sparklinetype" class="control" value={panelInfo.type} onChange={(e) => { typeChange(e) }}>
<option value="0">line</option>
<option value="1">column</option>
<option value="2">winloss</option>
</select>
</div>
<div class="option">
<label for="highMarkerColor" class="block">High Marker Color</label>
<input id='highMarkerColor' class="control" value={panelInfo.highMarkerColor} onChange={(e) => { highMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="lastMarkerColor" class="block">Last Marker Color</label>
<input id='lastMarkerColor' class="control" value={panelInfo.lastMarkerColor} onChange={(e) => { lastMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="lowMarkerColor" class="block">Low Marker Color</label>
<input id='lowMarkerColor' class="control" value={panelInfo.lowMarkerColor} onChange={(e) => { lowMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="negativeMarkerColor" class="block">Negative Marker Color</label>
<input id='negativeMarkerColor' class="control" value={panelInfo.negativeMarkerColor} onChange={(e) => { negativeMarkerColorChange(e) }} />
</div>
<div class="option">
<label for="markersColor" class="block">Markers Color</label>
<input id='markersColor' class="control" value={panelInfo.markersColor} onChange={(e) => { markersColorChange(e) }} />
</div>
<div class="option">
<label for="AxisColor" class="block">Axis Color</label>
<input id='AxisColor' class="control" value={panelInfo.axisColor} onChange={(e) => { axisColorChange(e) }} />
</div>
<div class="option">
<label for="SeriesColor" class="block">SeriesColor</label>
<input id='SeriesColor' class="control" value={panelInfo.seriesColor} onChange={(e) => { seriesColorChange(e) }} />
</div>
</div>
</div>
)
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option {
padding-bottom: 6px;
}
.block {
display: block;
padding: 6px 0;
}
.control {
padding: 4px 8px;
box-sizing: border-box;
width: 100%;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can highlight individual data markers (values) in a line sparkline by making some or all of the markers visible.
showFirst: whether the first data point is formatted differently for each sparkline in this sparkline group
showHigh: whether the data points with the highest value are formatted differently for each sparkline in this sparkline group
showLast: whether the last data point is formatted differently for each sparkline in this sparkline group
showLow: whether the data points with the lowest value are formatted differently for each sparkline in this sparkline group
showNegative: whether the negative data points are formatted differently for each sparkline in this sparkline group
showMarkers: whether data markers are displayed for each sparkline in this sparkline group
You can change the style and format of sparklines using the following methods:
axisColor: the color of the axis*
firstMarkerColor: the color of the first data point for each sparkline in this sparkline group
highMarkerColor: the color of the highest data point for each sparkline in this sparkline group
lastMarkerColor: the color of the last data point for each sparkline in this sparkline group
lowMarkerColor: the color of the lowest data point for each sparkline in this sparkline group
markersColor: the color of the data markers for each sparkline in this sparkline group
negativeColor: the color of the negative data points for each sparkline in this sparkline group
seriesColor: the color for each sparkline in this sparkline group
Sparklines offer additional settings. For example, sometimes there are empty values in the data series in the chart. You can use the displayEmptyCellsAs option to control how to display the empty cells, as shown in the following example:
The following example illustrates how to apply these settings:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
firstMarkerColor = '(none)';
buttonDisable = true;
type = 0;
highMarkerColor = 'Blue';
lastMarkerColor = '(none)';
lowMarkerColor = 'Blue';
negativeMarkerColor = 'Brown';
markersColor = '(none)';
axisColor = 'black';
seriesColor = '(none)';
showFirst = false;
showHigh = false;
showLast = false;
showLow = false;
showNegative = true;
showMarkers = false;
displayXAxis = true;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
buttonClick() {
let sheet = this.spread.getActiveSheet();
sheet.suspendPaint();
let sels = sheet.getSelections();
let setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
let sparklineType = this.type;
if (sels && sels.length > 0) {
let sel = this.getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount());
let sparkline = this.findSparkLine(sheet, sel);
if (sparkline != null) {
sparkline.setting(this.buildSparklineSettings(setting));
sparkline.sparklineType(sparklineType);
}
}
sheet.resumePaint();
}
showFirstChange(e: any) {
this.showFirst = e.target.checked;
}
showHighChange(e: any) {
this.showHigh = e.target.checked;
}
showLastChange(e: any) {
this.showLast = e.target.checked;
}
showLowChange(e: any) {
this.showLow = e.target.checked;
}
showNegativeChange(e: any) {
this.showNegative = e.target.checked;
}
showMarkersChange(e: any) {
this.showMarkers = e.target.checked;
}
displayXAxisChange(e: any) {
this.displayXAxis = e.target.checked;
}
firstMarkerColorChange(e: any) {
this.firstMarkerColor = e.target.value;
}
typeChange(e: any) {
this.type = parseInt(e.target.value);
}
highMarkerColorChange(e: any) {
this.highMarkerColor = e.target.value;
}
lastMarkerColorChange(e: any) {
this.lastMarkerColor = e.target.value;
}
lowMarkerColorChange(e: any) {
this.lowMarkerColor = e.target.value;
}
negativeMarkerColorChange(e: any) {
this.negativeMarkerColor = e.target.value;
}
markersColorChange(e: any) {
this.markersColor = e.target.value;
}
axisColorChange(e: any) {
this.axisColor = e.target.value;
}
seriesColorChange(e: any) {
this.seriesColor = e.target.value;
}
getActualRange(range: any, maxRowCount: number, maxColCount: number) {
let row = range.row < 0 ? 0 : range.row;
let col = range.col < 0 ? 0 : range.col;
let rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
let colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new GC.Spread.Sheets.Range(row, col, rowCount, colCount);
}
findSparkLine(sheet: GC.Spread.Sheets.Worksheet, range: any) {
let row = range.row,
col = range.col,
rowCount = range.rowCount,
colCount = range.colCount;
for (let i = 0; i < rowCount; i++) {
for (let j = 0; j < colCount; j++) {
let sparkline = sheet.getSparkline(row + i, col + j);
if (sparkline != null) {
return sparkline;
}
}
}
return null;
}
buildSparklineSettings(setting: any) {
if (setting == null) setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
let firstMarkerColor = this.firstMarkerColor;
if (firstMarkerColor != '(none)') setting.options.firstMarkerColor = firstMarkerColor;
let highMarkerColor = this.highMarkerColor;
if (highMarkerColor != '(none)') setting.options.highMarkerColor = highMarkerColor;
let lastMarkerColor = this.lastMarkerColor;
if (lastMarkerColor != '(none)') setting.options.lastMarkerColor = lastMarkerColor;
let lowMarkerColor = this.lowMarkerColor;
if (lowMarkerColor != '(none)') setting.options.lowMarkerColor = lowMarkerColor;
let negativeMarkerColor = this.negativeMarkerColor;
if (negativeMarkerColor != '(none)') setting.options.negativeColor = negativeMarkerColor;
let markersColor = this.markersColor;
if (markersColor != '(none)') setting.options.markersColor = markersColor;
let AxisColor = this.axisColor;
if (AxisColor != '(none)') setting.options.axisColor = AxisColor;
let SeriesColor = this.seriesColor;
if (SeriesColor != '(none)') setting.options.seriesColor = SeriesColor;
setting.options.showFirst = this.showFirst;
setting.options.showHigh = this.showHigh;
setting.options.showLast = this.showLast;
setting.options.showLow = this.showLow;
setting.options.showNegative = this.showNegative;
setting.options.showMarkers = this.showMarkers;
setting.options.displayXAxis = this.displayXAxis;
return setting;
}
initSpread($event: any) {
this.spread = $event.spread;
let self = this;
let sheet = this.spread.getSheet(0);
sheet.suspendPaint();
sheet.options.allowCellOverflow = true;
let spreadNS = GC.Spread.Sheets;
var data = [1,-2,-1,6,4,-4,3,8];
var dateAxis = [new Date(2011, 0, 5),new Date(2011, 0, 1),new Date(2011, 1, 11),new Date(2011, 2, 1),
new Date(2011, 1, 1),new Date(2011, 1, 3),new Date(2011, 2, 6),new Date(2011, 1, 19)];
sheet.setValue(0, 0, "Series 1");
sheet.setValue(0, 1, "Series 2");
for(let i=0;i<8;i++)
{
sheet.setValue(i+1, 0,data[i]);
sheet.getCell(i+1, 1).value(dateAxis[i]).formatter("yyyy-mm-dd");
}
sheet.setColumnWidth(1,100);
sheet.setValue(10, 0, "*Data Range is A2-A9");
sheet.setValue(11, 0, "*Date axis range is B2-B9");
var dataRange = new spreadNS.Range(1, 0, 8, 1);
var dateAxisRange = new spreadNS.Range(1, 1, 8, 1);
sheet.getCell(13, 0).text("Sparkline with dateAxis:");
sheet.getCell(14, 0).text("(1) Line");
sheet.getCell(14, 3).text("(2)Column");
sheet.getCell(14, 6).text("(3)Winloss");
//line
sheet.addSpan(15, 0, 4, 3);
var setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.showMarkers = true;
setting.options.displayXAxis = true;
setting.options.showFirst = true;
setting.options.showLast = true;
setting.options.showLow = true;
setting.options.showHigh = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 0, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.line
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
//column
sheet.addSpan(15, 3, 4, 3);
setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.displayXAxis = true;
setting.options.showFirst = true;
setting.options.showLast = true;
setting.options.showLow = true;
setting.options.showHigh = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 3, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.column
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
//winloss
sheet.addSpan(15, 6, 4, 3);
setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.displayXAxis = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 6, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.winloss
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical);
sheet.bind(GC.Spread.Sheets.Events.SelectionChanged, selectionChangedCallback);
sheet.resumePaint();
function selectionChangedCallback() {
let sheet = self.spread.getActiveSheet();
let sparkline = sheet.getSparkline(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (sparkline) {
getSparklineSettings(sparkline);
self.buttonDisable = false;
} else {
initSparklineSettings();
self.buttonDisable = true;
}
}
function initSparklineSettings() {
self.type = 0;
self.firstMarkerColor = '(none)';
self.highMarkerColor = 'Blue';
self.lastMarkerColor = '(none)';
self.lowMarkerColor = 'Blue';
self.negativeMarkerColor = 'Brown';
self.markersColor = '(none)';
self.axisColor = 'Black';
self.seriesColor = '(none)';
self.showFirst = false;
self.showHigh = false;
self.showLow = false;
self.showLast = false;
self.showNegative = false;
self.showMarkers = false;
self.displayXAxis = true;
}
function getSparklineSettings(sparkline: any) {
let setting = sparkline.setting();
self.type = sparkline.sparklineType();
self.firstMarkerColor = setting.options.firstMarkerColor;
self.highMarkerColor = setting.options.highMarkerColor;
self.lastMarkerColor = setting.options.lastMarkerColor;
self.lowMarkerColor = setting.options.lowMarkerColor;
self.negativeMarkerColor = setting.options.negativeColor;
self.markersColor = setting.options.markersColor;
self.axisColor = setting.options.axisColor;
self.seriesColor = setting.options.seriesColor;
self.showFirst = setting.options.showFirst;
self.showHigh = setting.options.showHigh;
self.showLow = setting.options.showLow;
self.showLast = setting.options.showLast;
self.showNegative = setting.options.showNegative;
self.showMarkers = setting.options.showMarkers;
self.displayXAxis = setting.options.displayXAxis;
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label>*Select a sparkline in the spreadsheet then change its properties</label>
</div>
<div class="option-row">
<div class="option">
<input id='btnChangeSetting' type='button' [disabled] = "buttonDisable" value='Change Settings' (click) = "buttonClick($event)"/>
</div>
</div>
<div class="option-row">
<div class="option">
<input [checked]="showFirst" id='showFirst' type='checkbox' (change) = "showFirstChange($event)"/>
<label for="showFirst">showFirst</label>
</div>
<div class="option">
<input [checked]="showHigh" id='showHigh' type='checkbox' (change) = "showHighChange($event)"/>
<label for="showHigh">showHigh</label>
</div>
<div class="option">
<input id='showLast' type='checkbox' [checked]="showLast" (change) = "showLastChange($event)"/>
<label for="showLast">showLast</label>
</div>
<div class="option">
<input id='showLow' type='checkbox' [checked]="showLow" (change) = "showLowChange($event)"/>
<label for="showLow">showLow</label>
</div>
<div class="option">
<input id='showNegative' type='checkbox' [checked]="showNegative" (change) = "showNegativeChange($event)"/>
<label for="showNegative">showNegative</label>
</div>
<div class="option">
<input id='showMarkers' type='checkbox' [checked]="showMarkers" (change) = "showMarkersChange($event)"/>
<label for="showMarkers">showMarkers</label>
</div>
<div class="option">
<input id="displayXAxis" type="checkbox" [checked]="displayXAxis" (change) = "displayXAxisChange($event)"/>
<label for="displayXAxis">displayXAxis</label>
</div>
</div>
<div class="option-row">
<div class="option">
<label for="firstMarkerColor" class="block">First Marker Color</label>
<input id='firstMarkerColor' class="control" [value]="firstMarkerColor" (change) = "firstMarkerColorChange($event)"/>
</div>
<div class="option">
<label for="sparklinetype" class="block">Type:</label>
<select id="sparklinetype" class="control" [value] = "type" (change) = "typeChange($event)">
<option value="0">line</option>
<option value="1">column</option>
<option value="2">winloss</option>
</select>
</div>
<div class="option">
<label for="highMarkerColor" class="block">High Marker Color</label>
<input id='highMarkerColor' class="control" [value]="highMarkerColor" (change) = "highMarkerColorChange($event)"/>
</div>
<div class="option">
<label for="lastMarkerColor" class="block">Last Marker Color</label>
<input id='lastMarkerColor' class="control" [value]="lastMarkerColor" (change) = "lastMarkerColorChange($event)"/>
</div>
<div class="option">
<label for="lowMarkerColor" class="block">Low Marker Color</label>
<input id='lowMarkerColor' class="control" [value]="lowMarkerColor" (change) = "lowMarkerColorChange($event)"/>
</div>
<div class="option">
<label for="negativeMarkerColor" class="block">Negative Marker Color</label>
<input id='negativeMarkerColor' class="control" [value]="negativeMarkerColor" (change) = "negativeMarkerColorChange($event)"/>
</div>
<div class="option">
<label for="markersColor" class="block">Markers Color</label>
<input id='markersColor' class="control" [value]="markersColor" (change) = "markersColorChange($event)"/>
</div>
<div class="option">
<label for="AxisColor" class="block">Axis Color</label>
<input id='AxisColor' class="control" [value]="axisColor" (change) = "axisColorChange($event)"/>
</div>
<div class="option">
<label for="SeriesColor" class="block">SeriesColor</label>
<input id='SeriesColor' class="control" [value]="seriesColor" (change) = "seriesColorChange($event)"/>
</div>
</div>
</div>
</div>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option {
padding-bottom: 6px;
}
.block {
display: block;
padding: 6px 0;
}
.control {
padding: 4px 8px;
box-sizing: border-box;
width: 100%;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

You can highlight individual data markers (values) in a line sparkline by making some or all of the markers visible.
showFirst: whether the first data point is formatted differently for each sparkline in this sparkline group
showHigh: whether the data points with the highest value are formatted differently for each sparkline in this sparkline group
showLast: whether the last data point is formatted differently for each sparkline in this sparkline group
showLow: whether the data points with the lowest value are formatted differently for each sparkline in this sparkline group
showNegative: whether the negative data points are formatted differently for each sparkline in this sparkline group
showMarkers: whether data markers are displayed for each sparkline in this sparkline group
You can change the style and format of sparklines using the following methods:
axisColor: the color of the axis*
firstMarkerColor: the color of the first data point for each sparkline in this sparkline group
highMarkerColor: the color of the highest data point for each sparkline in this sparkline group
lastMarkerColor: the color of the last data point for each sparkline in this sparkline group
lowMarkerColor: the color of the lowest data point for each sparkline in this sparkline group
markersColor: the color of the data markers for each sparkline in this sparkline group
negativeColor: the color of the negative data points for each sparkline in this sparkline group
seriesColor: the color for each sparkline in this sparkline group
Sparklines offer additional settings. For example, sometimes there are empty values in the data series in the chart. You can use the displayEmptyCellsAs option to control how to display the empty cells, as shown in the following example:
The following example illustrates how to apply these settings:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label>*Select a sparkline in the spreadsheet then change its properties</label>
</div>
<div class="option-row">
<div class="option">
<input id='btnChangeSetting' type='button' :disabled="buttonDisableRef" value='Change Setting'
v-on:click="buttonClick" />
</div>
</div>
<div class="option-row">
<div class="option">
<input v-model="showFirstRef" id='showFirst' type='checkbox' v-on:change="showFirstChange" />
<label for="showFirst">showFirst</label>
</div>
<div class="option">
<input v-model="showHighRef" id='showHigh' type='checkbox' v-on:change="showHighChange" />
<label for="showHigh">showHigh</label>
</div>
<div class="option">
<input id='showLast' type='checkbox' v-model="showLastRef" v-on:change="showLastChange" />
<label for="showLast">showLast</label>
</div>
<div class="option">
<input id='showLow' type='checkbox' v-model="showLowRef" v-on:change="showLowChange" />
<label for="showLow">showLow</label>
</div>
<div class="option">
<input id='showNegative' type='checkbox' v-model="showNegativeRef" v-on:change="showNegativeChange" />
<label for="showNegative">showNegative</label>
</div>
<div class="option">
<input id='showMarkers' type='checkbox' v-model="showMarkersRef" v-on:change="showMarkersChange" />
<label for="showMarkers">showMarkers</label>
</div>
<div class="option">
<input id="displayXAxis" type="checkbox" v-model="displayXAxisRef" v-on:change="displayXAxisChange" />
<label for="displayXAxis">displayXAxis</label>
</div>
</div>
<div class="option-row">
<div class="option">
<label for="firstMarkerColor" class="block">First Marker Color</label>
<input id='firstMarkerColor' class="control" v-model="firstMarkerColorRef"
v-on:change="firstMarkerColorChange" />
</div>
<div class="option">
<label for="sparklinetype" class="block">Type:</label>
<select id="sparklinetype" class="control" v-model="typeRef" v-on:change="typeChange">
<option value="0">line</option>
<option value="1">column</option>
<option value="2">winloss</option>
</select>
</div>
<div class="option">
<label for="highMarkerColor" class="block">High Marker Color</label>
<input id='highMarkerColor' class="control" v-model="highMarkerColorRef"
v-on:change="highMarkerColorChange" />
</div>
<div class="option">
<label for="lastMarkerColor" class="block">Last Marker Color</label>
<input id='lastMarkerColor' class="control" v-model="lastMarkerColorRef"
v-on:change="lastMarkerColorChange" />
</div>
<div class="option">
<label for="lowMarkerColor" class="block">Low Marker Color</label>
<input id='lowMarkerColor' class="control" v-model="lowMarkerColorRef" v-on:change="lowMarkerColorChange" />
</div>
<div class="option">
<label for="negativeMarkerColor" class="block">Negative Marker Color</label>
<input id='negativeMarkerColor' class="control" v-model="negativeMarkerColorRef"
v-on:change="negativeMarkerColorChange" />
</div>
<div class="option">
<label for="markersColor" class="block">Markers Color</label>
<input id='markersColor' class="control" v-model="markersColorRef" v-on:change="markersColorChange" />
</div>
<div class="option">
<label for="AxisColor" class="block">Axis Color</label>
<input id='AxisColor' class="control" v-model="axisColorRef" v-on:change="axisColorChange" />
</div>
<div class="option">
<label for="SeriesColor" class="block">SeriesColor</label>
<input id='SeriesColor' class="control" v-model="seriesColorRef" v-on:change="seriesColorChange" />
</div>
</div>
</div>
</div>
</template>
<script setup>
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
import '@mescius/spread-sheets-vue'
const spreadRef = ref(null);
const firstMarkerColorRef = ref('(none)');
const buttonDisableRef = ref(true);
const typeRef = ref(0);
const highMarkerColorRef = ref('Blue');
const lastMarkerColorRef = ref('(none)');
const lowMarkerColorRef = ref('Blue');
const negativeMarkerColorRef = ref('Brown');
const markersColorRef = ref('(none)');
const axisColorRef = ref('black');
const seriesColorRef = ref('(none)');
const showFirstRef = ref(false);
const showHighRef = ref(false);
const showLastRef = ref(false);
const showLowRef = ref(false);
const showNegativeRef = ref(true);
const showMarkersRef = ref(false);
const displayXAxisRef = ref(true);
let buttonClick = function () {
let sheet = spreadRef.value.getActiveSheet();
sheet.suspendPaint();
let sels = sheet.getSelections();
let setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
let sparklineType = typeRef.value;
if (sels && sels.length > 0) {
let sel = getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount());
let sparkline = findSparkLine(sheet, sel);
if (sparkline != null) {
sparkline.setting(buildSparklineSettings(setting));
sparkline.sparklineType(sparklineType);
}
}
sheet.resumePaint();
}
let showFirstChange = function (e) {
showFirstRef.value = e.target.checked;
}
let showHighChange = function (e) {
showHighRef.value = e.target.checked;
}
let showLastChange = function (e) {
showLastRef.value = e.target.checked;
}
let showLowChange = function (e) {
showLowRef.value = e.target.checked;
}
let showNegativeChange = function (e) {
showNegativeRef.value = e.target.checked;
}
let showMarkersChange = function (e) {
showMarkersRef.value = e.target.checked;
}
let displayXAxisChange = function (e) {
displayXAxisRef.value = e.target.checked;
}
let firstMarkerColorChange = function (e) {
firstMarkerColorRef.value = e.target.value;
}
let typeChange = function (e) {
typeRef.value = parseInt(e.target.value);
}
let highMarkerColorChange = function (e) {
highMarkerColorRef.value = e.target.value;
}
let lastMarkerColorChange = function (e) {
lastMarkerColorRef.value = e.target.value;
}
let lowMarkerColorChange = function (e) {
lowMarkerColorRef.value = e.target.value;
}
let negativeMarkerColorChange = function (e) {
negativeMarkerColorRef.value = e.target.value;
}
let markersColorChange = function (e) {
markersColorRef.value = e.target.value;
}
let axisColorChange = function (e) {
axisColorRef.value = e.target.value;
}
let seriesColorChange = function (e) {
seriesColorRef.value = e.target.value;
}
let getActualRange = function (range, maxRowCount, maxColCount) {
let row = range.row < 0 ? 0 : range.row;
let col = range.col < 0 ? 0 : range.col;
let rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
let colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new GC.Spread.Sheets.Range(row, col, rowCount, colCount);
}
let findSparkLine = function (sheet, range) {
let row = range.row,
col = range.col,
rowCount = range.rowCount,
colCount = range.colCount;
for (let i = 0; i < rowCount; i++) {
for (let j = 0; j < colCount; j++) {
let sparkline = sheet.getSparkline(row + i, col + j);
if (sparkline != null) {
return sparkline;
}
}
}
return null;
}
let buildSparklineSettings = function (setting) {
if (setting == null) setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
let firstMarkerColor = firstMarkerColorRef.value;
if (firstMarkerColor != '(none)') setting.options.firstMarkerColor = firstMarkerColor;
let highMarkerColor = highMarkerColorRef.value;
if (highMarkerColor != '(none)') setting.options.highMarkerColor = highMarkerColor;
let lastMarkerColor = lastMarkerColorRef.value;
if (lastMarkerColor != '(none)') setting.options.lastMarkerColor = lastMarkerColor;
let lowMarkerColor = lowMarkerColorRef.value;
if (lowMarkerColor != '(none)') setting.options.lowMarkerColor = lowMarkerColor;
let negativeMarkerColor = negativeMarkerColorRef.value;
if (negativeMarkerColor != '(none)') setting.options.negativeColor = negativeMarkerColor;
let markersColor = markersColorRef.value;
if (markersColor != '(none)') setting.options.markersColor = markersColor;
let AxisColor = axisColorRef.value;
if (AxisColor != '(none)') setting.options.axisColor = AxisColor;
let SeriesColor = seriesColorRef.value;
if (SeriesColor != '(none)') setting.options.seriesColor = SeriesColor;
setting.options.showFirst = showFirstRef.value;
setting.options.showHigh = showHighRef.value;
setting.options.showLast = showLastRef.value;
setting.options.showLow = showLowRef.value;
setting.options.showNegative = showNegativeRef.value;
setting.options.showMarkers = showMarkersRef.value;
setting.options.displayXAxis = displayXAxisRef.value;
return setting;
}
let initSpread = function (spread) {
spreadRef.value = spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.allowCellOverflow = true;
let spreadNS = GC.Spread.Sheets;
var data = [1, -2, -1, 6, 4, -4, 3, 8];
var dateAxis = [new Date(2011, 0, 5), new Date(2011, 0, 1), new Date(2011, 1, 11), new Date(2011, 2, 1),
new Date(2011, 1, 1), new Date(2011, 1, 3), new Date(2011, 2, 6), new Date(2011, 1, 19)];
sheet.setValue(0, 0, "Series 1");
sheet.setValue(0, 1, "Series 2");
for (let i = 0; i < 8; i++) {
sheet.setValue(i + 1, 0, data[i]);
sheet.getCell(i + 1, 1).value(dateAxis[i]).formatter("yyyy-mm-dd");
}
sheet.setColumnWidth(1, 100);
sheet.setValue(10, 0, "*Data Range is A2-A9");
sheet.setValue(11, 0, "*Date axis range is B2-B9");
var dataRange = new spreadNS.Range(1, 0, 8, 1);
var dateAxisRange = new spreadNS.Range(1, 1, 8, 1);
sheet.getCell(13, 0).text("Sparkline with dateAxis:");
sheet.getCell(14, 0).text("(1) Line");
sheet.getCell(14, 3).text("(2)Column");
sheet.getCell(14, 6).text("(3)Winloss");
//line
sheet.addSpan(15, 0, 4, 3);
var setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.showMarkers = true;
setting.options.displayXAxis = true;
setting.options.showFirst = true;
setting.options.showLast = true;
setting.options.showLow = true;
setting.options.showHigh = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 0, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.line
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
//column
sheet.addSpan(15, 3, 4, 3);
setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.displayXAxis = true;
setting.options.showFirst = true;
setting.options.showLast = true;
setting.options.showLow = true;
setting.options.showHigh = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 3, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.column
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
//winloss
sheet.addSpan(15, 6, 4, 3);
setting = new spreadNS.Sparklines.SparklineSetting();
setting.options.displayXAxis = true;
setting.options.showNegative = true;
sheet.setSparkline(15, 6, dataRange
, spreadNS.Sparklines.DataOrientation.vertical
, spreadNS.Sparklines.SparklineType.winloss
, setting
, dateAxisRange
, spreadNS.Sparklines.DataOrientation.vertical
);
sheet.bind(GC.Spread.Sheets.Events.SelectionChanged, selectionChangedCallback);
sheet.resumePaint();
function selectionChangedCallback() {
let sheet = spreadRef.value.getActiveSheet();
let sparkline = sheet.getSparkline(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex());
if (sparkline) {
getSparklineSettings(sparkline);
buttonDisableRef.value = false;
} else {
initSparklineSettings();
buttonDisableRef.value = true;
}
}
function initSparklineSettings() {
typeRef.value = 0;
firstMarkerColorRef.value = '(none)';
highMarkerColorRef.value = 'Blue';
lastMarkerColorRef.value = '(none)';
lowMarkerColorRef.value = 'Blue';
negativeMarkerColorRef.value = 'Brown';
markersColorRef.value = '(none)';
axisColorRef.value = 'Black';
seriesColorRef.value = '(none)';
showFirstRef.value = false;
showHighRef.value = false;
showLowRef.value = false;
showLastRef.value = false;
showNegativeRef.value = false;
showMarkersRef.value = false;
displayXAxisRef.value = true;
}
function getSparklineSettings(sparkline) {
let setting = sparkline.setting();
typeRef.value = sparkline.sparklineType();
firstMarkerColorRef.value = setting.options.firstMarkerColor;
highMarkerColorRef.value = setting.options.highMarkerColor;
lastMarkerColorRef.value = setting.options.lastMarkerColor;
lowMarkerColorRef.value = setting.options.lowMarkerColor;
negativeMarkerColorRef.value = setting.options.negativeColor;
markersColorRef.value = setting.options.markersColor;
axisColorRef.value = setting.options.axisColor;
seriesColorRef.value = setting.options.seriesColor;
showFirstRef.value = setting.options.showFirst;
showHighRef.value = setting.options.showHigh;
showLowRef.value = setting.options.showLow;
showLastRef.value = setting.options.showLast;
showNegativeRef.value = setting.options.showNegative;
showMarkersRef.value = setting.options.showMarkers;
displayXAxisRef.value = setting.options.displayXAxis;
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option {
padding-bottom: 6px;
}
.block {
display: block;
padding: 6px 0;
}
.control {
padding: 4px 8px;
box-sizing: border-box;
width: 100%;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);